Public Member Functions | Protected Member Functions | Static Protected Member Functions | Friends

# OGRPolygon Class Reference

Concrete class representing polygons. More...

`#include <ogr_geometry.h>`

Inheritance diagram for OGRPolygon:

List of all members.

## Public Member Functions
| OGRPolygon ()
| Create an empty polygon.
virtual const char * | getGeometryName () const
| Fetch WKT name for geometry type.
virtual OGRwkbGeometryType | getGeometryType () const
| Fetch geometry type.
virtual OGRBoolean | hasCurveGeometry (int bLookForNonLinear=FALSE) const
virtual OGRGeometry * | getCurveGeometry (const char *const *papszOptions=NULL) const
virtual OGRGeometry * | getLinearGeometry (double dfMaxAngleStepSizeDegrees=0, const char *const *papszOptions=NULL) const
virtual int | PointOnSurface (OGRPoint *poPoint) const
| This method relates to the SFCOM ISurface::get_PointOnSurface() method.
virtual int | WkbSize () const
| Returns size of related binary representation.
virtual OGRErr | importFromWkb (unsigned char *, int=-1, OGRwkbVariant=wkbVariantOldOgc)
| Assign geometry from well known binary data.
virtual OGRErr | exportToWkb (OGRwkbByteOrder, unsigned char *, OGRwkbVariant=wkbVariantOldOgc) const
| Convert a geometry into well known binary format.
virtual OGRErr | importFromWkt (char **)
| Assign geometry from well known text data.
virtual OGRErr | exportToWkt (char **ppszDstText, OGRwkbVariant=wkbVariantOldOgc) const
| Convert a geometry into well known text format.
virtual OGRPolygon * | CurvePolyToPoly (double dfMaxAngleStepSizeDegrees=0, const char *const *papszOptions=NULL) const
| Return a polygon from a curve polygon.
OGRLinearRing * | getExteriorRing ()
| Fetch reference to external polygon ring.
const OGRLinearRing * | getExteriorRing () const
OGRLinearRing * | getInteriorRing (int)
| Fetch reference to indicated internal ring.
const OGRLinearRing * | getInteriorRing (int) const
OGRLinearRing * | stealExteriorRing ()
| "Steal" reference to external polygon ring.
OGRLinearRing * | stealInteriorRing (int)
| "Steal" reference to indicated interior ring.
OGRBoolean | IsPointOnSurface (const OGRPoint *) const
virtual void | closeRings ()
| Force rings to be closed.
## Protected Member Functions
virtual int | checkRing (OGRCurve *poNewRing) const
OGRErr | importFromWKTListOnly (char **ppszInput, int bHasZ, int bHasM, OGRRawPoint *&paoPoints, int &nMaxPoints, double *&padfZ)
virtual OGRSurfaceCasterToPolygon | GetCasterToPolygon () const
virtual OGRSurfaceCasterToCurvePolygon | GetCasterToCurvePolygon () const
## Static Protected Member Functions
static OGRCurvePolygon * | CastToCurvePolygon (OGRPolygon *poPoly)
| Cast to curve polygon.
## Friends
class | OGRMultiSurface

## Detailed Description

Concrete class representing polygons.

Note that the OpenGIS simple features polygons consist of one outer ring (linearring), and zero or more inner rings. A polygon cannot represent disconnected regions (such as multiple islands in a political body). The OGRMultiPolygon must be used for this.

## Member Function Documentation

OGRCurvePolygon * OGRPolygon::CastToCurvePolygon | ( | OGRPolygon * | poPoly | ) | `[static, protected]`

Cast to curve polygon.

The passed in geometry is consumed and a new one returned .

Parameters:

  | poPoly | the input geometry - ownership is passed to the method.

Returns:
  new geometry.

void OGRPolygon::closeRings | ( |  | ) | `[virtual]`

Force rings to be closed.

If this geometry, or any contained geometries has polygon rings that are not closed, they will be closed by adding the starting point at the end.

Reimplemented from OGRGeometry.

virtual OGRPolygon* OGRPolygon::CurvePolyToPoly | ( | double | dfMaxAngleStepSizeDegrees = `0`,
|  | const char *const * | papszOptions = `NULL` |
| ) |  |  | const`[virtual]`

Return a polygon from a curve polygon.

This method is the same as C function OGR_G_CurvePolyToPoly().

The returned geometry is a new instance whose ownership belongs to the caller.

Parameters:

  | dfMaxAngleStepSizeDegrees | the largest step in degrees along the arc, zero to use the default setting.
  | papszOptions | options as a null-terminated list of strings. Unused for now. Must be set to NULL.

Returns:
  a linestring

Since:
  OGR 2.0

Reimplemented from OGRCurvePolygon.

OGRErr OGRPolygon::exportToWkb | ( | OGRwkbByteOrder | eByteOrder,
|  | unsigned char * | pabyData,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc` |
| ) |  |  | const`[virtual]`

Convert a geometry into well known binary format.

This method relates to the SFCOM IWks::ExportToWKB() method.

This method is the same as the C function OGR_G_ExportToWkb() or OGR_G_ExportToIsoWkb(), depending on the value of eWkbVariant.

Parameters:

  | eByteOrder | One of wkbXDR or wkbNDR indicating MSB or LSB byte order respectively.
  | pabyData | a buffer into which the binary representation is written. This buffer must be at least OGRGeometry::WkbSize() byte in size.
  | eWkbVariant | What standard to use when exporting geometries with three dimensions (or more). The default wkbVariantOldOgc is the historical OGR variant. wkbVariantIso is the variant defined in ISO SQL/MM and adopted by OGC for SFSQL 1.2.

Returns:
  Currently OGRERR_NONE is always returned.

Reimplemented from OGRCurvePolygon.

OGRErr OGRPolygon::exportToWkt | ( | char ** | ppszDstText,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc` |
| ) |  |  | const`[virtual]`

Convert a geometry into well known text format.

This method relates to the SFCOM IWks::ExportToWKT() method.

This method is the same as the C function OGR_G_ExportToWkt().

Parameters:

  | ppszDstText | a text buffer is allocated by the program, and assigned to the passed pointer. After use, *ppszDstText should be freed with OGRFree().
  | eWkbVariant | the specification that must be conformed too : wbkVariantOgc for old-style 99-402 extended dimension (Z) WKB types wbkVariantIso for SFSQL 1.2 and ISO SQL/MM Part 3

Returns:
  Currently OGRERR_NONE is always returned.

Reimplemented from OGRCurvePolygon.

OGRLinearRing * OGRPolygon::getExteriorRing | ( |  | ) |

Fetch reference to external polygon ring.

Note that the returned ring pointer is to an internal data object of the OGRPolygon. It should not be modified or deleted by the application, and the pointer is only valid till the polygon is next modified. Use the OGRGeometry::clone() method to make a separate copy within the application.

Relates to the SFCOM IPolygon::get_ExteriorRing() method.

Returns:
  pointer to external ring. May be NULL if the OGRPolygon is empty.

const char * OGRPolygon::getGeometryName | ( |  | ) | const`[virtual]`

Fetch WKT name for geometry type.

There is no SFCOM analog to this method.

This method is the same as the C function OGR_G_GetGeometryName().

Returns:
  name used for this geometry type in well known text format. The returned pointer is to a static internal string and should not be modified or freed.

Reimplemented from OGRCurvePolygon.

OGRwkbGeometryType OGRPolygon::getGeometryType | ( |  | ) | const`[virtual]`

Fetch geometry type.

Note that the geometry type may include the 2.5D flag. To get a 2D flattened version of the geometry type apply the wkbFlatten() macro to the return result.

This method is the same as the C function OGR_G_GetGeometryType().

Returns:
  the geometry type code.

Reimplemented from OGRCurvePolygon.

OGRLinearRing * OGRPolygon::getInteriorRing | ( | int | iRing | ) |

Fetch reference to indicated internal ring.

Note that the returned ring pointer is to an internal data object of the OGRPolygon. It should not be modified or deleted by the application, and the pointer is only valid till the polygon is next modified. Use the OGRGeometry::clone() method to make a separate copy within the application.

Relates to the SFCOM IPolygon::get_InternalRing() method.

Parameters:

  | iRing | internal ring index from 0 to getNumInternalRings() - 1.

Returns:
  pointer to interior ring. May be NULL.

OGRErr OGRPolygon::importFromWkb | ( | unsigned char * | pabyData,
|  | int | nSize = `-1`,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc` |
| ) |  |  | `[virtual]`

Assign geometry from well known binary data.

The object must have already been instantiated as the correct derived type of geometry object to match the binaries type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKB() method.

This method is the same as the C function OGR_G_ImportFromWkb().

Parameters:

  | pabyData | the binary input data.
  | nSize | the size of pabyData in bytes, or zero if not known.
  | eWkbVariant | if wkbVariantPostGIS1, special interpretation is done for curve geometries code

Returns:
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Reimplemented from OGRCurvePolygon.

OGRErr OGRPolygon::importFromWkt | ( | char ** | ppszInput | ) | `[virtual]`

Assign geometry from well known text data.

The object must have already been instantiated as the correct derived type of geometry object to match the text type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKT() method.

This method is the same as the C function OGR_G_ImportFromWkt().

Parameters:

  | ppszInput | pointer to a pointer to the source text. The pointer is updated to pointer after the consumed text.

Returns:
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Reimplemented from OGRCurvePolygon.

int OGRPolygon::PointOnSurface | ( | OGRPoint * | poPoint | ) | const`[virtual]`

This method relates to the SFCOM ISurface::get_PointOnSurface() method.

NOTE: Only implemented when GEOS included in build.

Parameters:

  | poPoint | point to be set with an internal point.

Returns:
  OGRERR_NONE if it succeeds or OGRERR_FAILURE otherwise.

Reimplemented from OGRCurvePolygon.

OGRLinearRing * OGRPolygon::stealExteriorRing | ( |  | ) |

"Steal" reference to external polygon ring.

After the call to that function, only call to stealInteriorRing() or destruction of the OGRPolygon is valid. Other operations may crash.

Returns:
  pointer to external ring. May be NULL if the OGRPolygon is empty.

OGRLinearRing * OGRPolygon::stealInteriorRing | ( | int | iRing | ) |

"Steal" reference to indicated interior ring.

After the call to that function, only call to stealInteriorRing() or destruction of the OGRPolygon is valid. Other operations may crash.

Parameters:

  | iRing | internal ring index from 0 to getNumInternalRings() - 1.

Returns:
  pointer to interior ring. May be NULL.

int OGRPolygon::WkbSize | ( |  | ) | const`[virtual]`

Returns size of related binary representation.

This method returns the exact number of bytes required to hold the well known binary representation of this geometry object. Its computation may be slightly expensive for complex geometries.

This method relates to the SFCOM IWks::WkbSize() method.

This method is the same as the C function OGR_G_WkbSize().

Returns:
  size of binary representation in bytes.

Reimplemented from OGRCurvePolygon.

The documentation for this class was generated from the following files:

- ogr_geometry.h
- ogrpolygon.cpp

Generated for GDAL by 1.7.1.